package farm.ants.agent;

/**
 * Simple holds the name and value of a resource (sensors) for accomplishing
 * a goal (tracking a target)
 * <p>
 * Created: Wed Aug  7 15:51:44 2002
 *
 * @author Roger Mailler
 */
public class SensorData implements Comparable{
    /**
     * Constructor
     */
    public SensorData() {
	
    }

    /**
     * Constructor
     * @param n The name
     * @param the value
     */
    public SensorData(String n, float v) {
	setName(n);
	setValue(v);
    }
    
    /**
     * Constructor
     * @param s A space delimeted string with the two values in it
     */
    public SensorData(String n) {
	setName(n.substring(0, n.indexOf(" ")));
	setValue(Float.parseFloat(n.substring(n.indexOf(" ")+1)));
    }

    String name;
    
    /**
       * Get the value of name.
       * @return Value of name.
       */
    public String getName() {return name;}
    
    /**
       * Set the value of name.
       * @param v  Value to assign to name.
       */
    public void setName(String  v) {this.name = v;}
    

    float value = 1f;
    
    /**
       * Get the value of value.
       * @return Value of value.
       */
    public float getValue() {return value;}
    
    /**
       * Set the value of value.
       * @param v  Value to assign to value.
       */
    public void setValue(float  v) {this.value = v;}
   
     /**
      * Compares the value of this object to another
      * @param o1  The object to compare to
      * @return -1 if this goes before o1, 0 if equals, 1 if o1 goes before this
      */
    public int compareTo(Object o1){
	if(this.value < ((SensorData) o1).getValue())
	    return -1;
	else if (this.value > ((SensorData) o1).getValue())
	    return 1;
	else
	    return 0;
    }

    /**
     * Checks to see if the name in the two SensorData are the same.
     */
    public boolean equals(Object o1){
	return this.getName().equals(((SensorData) o1).getName());
    }

    /**
     * Returns a String describing the Sensor
     * @return the description
     */
    public String toString(){
	return this.getName() + " " + this.getValue();
    }


} // SensorData
