package farm.ants.agent;
import java.util.*;
/**
 * SolutionSet.java
 *
 *
 * Created: Tue Aug 20 14:15:01 2002
 *
 * @author Roger Mailler
 */

public class SolutionSet  {

    Hashtable globalSolns = new Hashtable();
    Hashtable testMap = new Hashtable();
    Vector globalSolnMap = new Vector();

    /**
     * Contructor
     */
    public SolutionSet() {	
    }
    
    /**
     * Adds a solution the the list of solutions
     * @param sol The solution
     */
    public void addSolution(Solution sol){
	Vector thisSolnMap = new Vector();
	for(Iterator i = sol.keySet().iterator();i.hasNext();){
	    String name = (String) i.next();
	    ResourceSchedule RS = (ResourceSchedule) sol.get(name);
	    Vector partialSolns;
	    HashMap thisTestMap;
	    
	    if(!globalSolns.containsKey(name)){
		partialSolns = new Vector();
		globalSolns.put(name, partialSolns);
	    }
	    else{
		partialSolns  = (Vector) globalSolns.get(name);
	    }
	    
	    if(!testMap.containsKey(name)){
		thisTestMap = new HashMap();
		testMap.put(name, thisTestMap);
	    }
	    else{
		thisTestMap =  (HashMap) testMap.get(name);
	    }	

	    Integer index = (Integer) thisTestMap.get(RS.toString());
	    if(index != null){
		//System.out.println("Got it");
		 thisSolnMap.add(index);
	    }
	    else{
		thisSolnMap.add(new Integer(partialSolns.size()));
		thisTestMap.put(RS.toString(), new Integer(partialSolns.size()));
		partialSolns.add(RS);	
	    }
	}
	globalSolnMap.add(thisSolnMap);
    }
	    
	    
    /**
     * Returns a list of partial solution for a particular manager
     * @param who The manager name
     * @return A vector of ResourceSchedules
     */
    public Vector getPartialSol(String who){
	return (Vector) globalSolns.get(who);
    }

    /**
     * Returns a hashtbale of the partial solutions for the managers
     * @return The partial solutions keyed on manager name
     */
    public Hashtable getSolns(){
	return globalSolns;
    }

    /**
     * Gets the mapping that is used to recreate all of the solutions
     * that have been added to the SolutionSet
     * @return a Vector of Vectors representing the mapping
     */
    public Vector getSolnsMap(){
	return globalSolnMap;
    }
} // SolutionSet
