package farm.generic.plugins.drivers;

import java.rmi.*;
import java.rmi.server.*;
import farm.simulator.*;

import java.util.*;

/**
 * This is a simple utility class, which will tell the simulation to stop
 * immediately after connecting to it.  This can be used to gracefully stop
 * simulation runs if no other user interface is available to do so.
 */
public class KillDriver extends FarmPlugIn {

    /**
     * Constructor
     * @param address The address of the remote simulator to eonnect to
     */
    public KillDriver(String []args)throws RemoteException {
        super(args);

        // Init
        setPlugInName(getCommandLineArgument(args, CLA_NAME, "Assassin"));
    }


    /**
     * When called, the setStop function of the simulation will be
     * performed, telling it to remove all plugins and end the
     * simulation.
     */
    public void begin() {

        try {
            simulator.setStop();
        } catch (RemoteException e) {
            System.err.println("Exception: " + e.getMessage());
            e.printStackTrace();
        }
    }

    /**
     * When called, the setStop function of the simulation will be
     * performed, telling it to remove all plugins and end the
     * simulation.
     */
    public void pulseEnd() {

        try {
            simulator.setStop();
        } catch (RemoteException e) {
            System.err.println("Exception: " + e.getMessage());
            e.printStackTrace();
        }
    }

    /**
     * The main function
     */
    public static void main(String[] args) {

        try {
            FarmPlugIn plugin = new KillDriver(args);
            plugin.run();
        } catch (RemoteException e) {
            System.err.println("Exception: " + e.getMessage());
            e.printStackTrace();
        }
    }
}
