package farm.sat.plugins.display;
/**
 * NodeLink.java
 *
 *
 * Created: Mon Dec 17 12:35:24 2001
 *
 * @author Roger Mailler
 * @version
 */
import java.util.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.font.*;
public class NodeLink  {
    String who;
    String what = "";
    boolean done = false;
    boolean hot = false;
    Color coldColor = new Color(0,0,0);
    Color hotColor = new Color(255,0,0);

    public NodeLink(String w){
	who = w;
    }

    void setHot(){hot = true;}
    void resetHot(){
	hot=false;
    }

    boolean isHot(){return hot;}
    void resetDone(){done = false;}
    void setDone(){done = true;}
    boolean done(){return done;}
    String getWho(){return who;}

    void setConstraint(String rel){
	what = rel;
    }
    String getConstraint(){
	return what;
    }
    public String toString(){
	return "link to: " + who + " constraint: " + what;    
    }

    void draw(Graphics g, int x1, int y1, int x2, int y2, boolean text){

	Graphics2D g2 = (Graphics2D) g;
	
	if(x1==x2 && y1==y2) return;
	Color c = g.getColor();


	g.setColor(coldColor);

	if(text){
	    //what is the line length
	    float deltax = x2-x1;
	    float deltay = y2-y1;
	    float length = (float) Math.sqrt(deltax*deltax + deltay*deltay);
	    
	    //make sure we're not drawing too much text
	    TextLayout upperTl = new TextLayout(what, g2.getFont(), g2.getFontRenderContext());
	    float width = (float)upperTl.getBounds().getWidth();
	    while(width > length && what.length() > 1){
		what = what.substring(0,what.length()-1);
		upperTl = new TextLayout(what, g2.getFont(), g2.getFontRenderContext());
		width = (float)upperTl.getBounds().getWidth();
	    }
	    
	    //where is the center for the line?
	    float middlex = (float)(deltax/2) + x1;
	    float middley = (float)(deltay/2) + y1;
	    //figure out the rotation angle
	    double theta = Math.atan(deltay/deltax);
	    
	    AffineTransform saveXform = g2.getTransform();
	    g2.rotate(theta, middlex, middley);
	    upperTl.draw(g2,middlex-(width/2), middley);
	    g2.setTransform(saveXform);
	}
	//is it hot?
	if(hot){
	    g.setColor(hotColor);
	}	
	else{
	    g2.setColor(coldColor);
	}
	//draw the line
	g2.drawLine(x1, y1, x2, y2);

	//reset the color
	g.setColor(c);
    }
} // NodeLink
