/**
 */

package farm.simulator;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Collection;

/**
 * This interface is implemented by anything that can be
 * a property owner, including the simulator and plugins.
 */
public interface PropertyOwner extends Remote {

    // Property accessors used remotely
    public Object getPropertyRemote(String name) throws RemoteException;
    public DataToken setPropertyRemote(String name, Object value) throws RemoteException;

    // General property accessors used locally
    public Object getProperty(String name) throws RemoteException;
    public boolean setProperty(String name, Object value) throws RemoteException;
    public Collection findProperties(String name) throws RemoteException;

    // Property accessors to access only local data
    public Object getLocalProperty(String name) throws RemoteException;
    public void setLocalProperty(String name, Object value) throws RemoteException;
    public Collection findLocalProperties(String name) throws RemoteException;

    // They can all run mobile code
    public Object runLocalFunction(LocalFunction function) throws RemoteException;
}
